'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bootAction = exports.BOOT = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = boot;

var _reduxActions = require('redux-actions');

var _processModules2 = require('./processModules');

var _processModules3 = _interopRequireDefault(_processModules2);

var _configureStore = require('./configureStore');

var _configureStore2 = _interopRequireDefault(_configureStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BOOT = exports.BOOT = 'redux-boot/BOOT';

function boot() {
  var initialState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var modules = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  var _processModules = (0, _processModules3.default)(modules),
      reducers = _processModules.reducers,
      middlewares = _processModules.middlewares,
      enhancers = _processModules.enhancers;

  var store = (0, _configureStore2.default)(initialState, reducers, middlewares, enhancers);

  return store.dispatch(bootAction(initialState)).then(function (action) {
    return {
      action: action,
      store: store
    };
  });
}

var bootAction = exports.bootAction = (0, _reduxActions.createAction)(BOOT, function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(initialState) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', initialState);

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function (_x3) {
    return _ref.apply(this, arguments);
  };
}());